/* dummy cilk-cilk2c.h file */

typedef struct
{
  int size;
  int entry;
  int index;
  void (*fn) ();
} StackFrameT;

typedef struct
{
  int size;
  int index;
  void (*inlet) ();
  int argsize;
  int argindex;
} ProcInfoT;

typedef struct {
  void (*slow) ();
  ProcInfoT *sig;
} ProcSigT;

StackFrameT *Cilk_head;
StackFrameT *Cilk_tail;

int Cilk_result_valid;
char Cilk_result[100];
int Cilk_join_count;

int Cilk_resume;
int Cilk_abort;

/* add current frame to deque */
#define _PUSH_FRAME(f) {\
    Cilk_tail = (StackFrameT*)((char*)f+f->header.size);\
}

#define _INIT_FRAME(f,s,slow) { \
     f = (void*)Cilk_tail; \
     f->header.size = (s); \
     f->header.fn = (slow); \
}

#define _CHILD_VALID(f) !Cilk_result_valid
#define _SET_RESULT(x) *((typeof(x)*)Cilk_result) = x
#define _SET_VALID Cilk_result_valid = 1
#define _SYNC Cilk_join_count

#define _HEAPIFY(f)

#define _RESUME() Cilk_resume = 1
#define _ABORT_SLOW() Cilk_abort = 1
#define _ABORT_STANDALONE() Cilk_abort = 1

#define _XPOP_FRAME_RESULT(f, r, result) \
{ \
     Cilk_tail = (StackFrameT *)f; \
     if (Cilk_head > (StackFrameT *) f) {\
	  if (_CHILD_VALID(f)) { _SET_RESULT(result); _SET_VALID; } \
	  return r ; \
     }\
} 

#define _XPOP_FRAME_NORESULT(f, r)  \
{ \
     Cilk_tail = (StackFrameT *)f; \
     if (Cilk_head > (StackFrameT *) f) {\
	  if (_CHILD_VALID(f)) { _SET_VALID; } \
	  return r ; \
     }\
} 

#define offsetof(type, mem) ((int) ((char *)&((type *) 0)->mem - (char *)((type *) 0)))

