/*
 * $Id: cilk-compat.h,v 1.5 1996/06/07 17:55:42 athena Exp $
 */
/*
 * $Log: cilk-compat.h,v $
 * Revision 1.5  1996/06/07 17:55:42  athena
 * Fixed copyrights. I hate this.
 *
 * Revision 1.4  1996/06/06 14:37:38  athena
 * cilk_main is now main
 *
 * Revision 1.3  1996/06/05 15:37:40  athena
 * Added cilk-lib.h, and updated stuff
 *
 * Revision 1.2  1996/06/04 16:32:32  athena
 * Adapted examples, because inlet_call is no longer there.
 *
 * Revision 1.1  1996/06/04 16:05:46  athena
 * Added cilk-compat.h
 *
 */

/*
 * Copyright (c) 1996 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to use, copy, modify, and distribute the Software without
 * restriction, provided the Software, including any modified copies made
 * under this license, is not distributed for a fee, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE MASSACHUSETTS INSTITUTE OF TECHNOLOGY BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of the Massachusetts
 * Institute of Technology shall not be used in advertising or otherwise
 * to promote the sale, use or other dealings in this Software without
 * prior written authorization from the Massachusetts Institute of
 * Technology.
 *  
 */

#include <stdlib.h>

/* first of all, save the old functions somewhere */
static inline void *C_malloc(size_t size)
{
     return malloc(size);
}

static inline void *C_memalign(size_t alignment, size_t size)
{
     return memalign(alignment, size);
}

static inline void C_free(void *s)
{
     free(s);
}

/*
 * Then redefine some functions to use the Cilk emulations.
 */

/* malloc() and company */
#define malloc Cilk_malloc
#define free Cilk_free
#define memalign Cilk_memalign

/* alloca() --- still an open problem */
#define alloca Cilk_alloca

/* rand() and company */
#define rand Cilk_rand
#define srand Cilk_srand


